/*
 *  * Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 7.1 EDK_H.10.2
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    C:\xup_v2pro_dev_brd\edk_7_1_builds\xup_bsb_512M_dual_rank_vga
 */


// Located in: ppc405_0/include/xparameters.h
#include "xparameters.h"

#include "xutil.h"

//====================================================
// Function Prototype
int runTestPatternRGB(int  word_count);


// Start of Main
int main (void) {


   print("-- Entering main() --\r\n");

   /* Testing DDR Memory (DDR_512MB_64Mx64_rank2_row13_col10_cl2_5)*/
   {
      XStatus status;

      print("Starting MemoryTest for DDR_512MB_64Mx64_rank2_row13_col10_cl2_5:\r\n");
      print("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)XPAR_DDR_512MB_64MX64_RANK2_ROW13_COL10_CL2_5_MEM0_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
      print("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)XPAR_DDR_512MB_64MX64_RANK2_ROW13_COL10_CL2_5_MEM0_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
      print("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)XPAR_DDR_512MB_64MX64_RANK2_ROW13_COL10_CL2_5_MEM0_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }

      print("Starting MemoryTest for DDR_512MB_64Mx64_rank2_row13_col10_cl2_5:\r\n");
      print("  Running 32-bit test...");
      status = XUtil_MemoryTest32((Xuint32*)XPAR_DDR_512MB_64MX64_RANK2_ROW13_COL10_CL2_5_MEM1_BASEADDR, 1024, 0xAAAA5555, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
      print("  Running 16-bit test...");
      status = XUtil_MemoryTest16((Xuint16*)XPAR_DDR_512MB_64MX64_RANK2_ROW13_COL10_CL2_5_MEM1_BASEADDR, 2048, 0xAA55, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
      print("  Running 8-bit test...");
      status = XUtil_MemoryTest8((Xuint8*)XPAR_DDR_512MB_64MX64_RANK2_ROW13_COL10_CL2_5_MEM1_BASEADDR, 4096, 0xA5, XUT_ALLMEMTESTS);
      if (status == XST_SUCCESS) {
         print("PASSED!\r\n");
      }
      else {
         print("FAILED!\r\n");
      }
   }

   /* 
    * MemoryTest routine will not be run for the memory at 
    * 0xffffc000 (plb_bram_if_cntlr_1)
    * because it is being used to hold a part of this application program
    */

   runTestPatternRGB(309760);


   print("-- Exiting main() --\r\n");
   return 0;
}

int runTestPatternRGB(int  word_count) {
  unsigned int i, x, wordnum;
  volatile unsigned int rgb_value;
  unsigned int block_start; 
  unsigned int pattern;
  unsigned int test_val;
  unsigned int  *pDisplay_data;

//  pDisplay_data   = (unsigned int  *)0x0FE00000;
  pDisplay_data   = (unsigned int  *)0x07E00000;

  print("\n\rRunning rgb Test Pattern...\t");

  print("...\t");
  x = wordnum = 0;

  // write pattern to DDR
  while (wordnum < word_count)
	{
		// Color pattern
		if (x < 80)
			rgb_value = 0x00FFFFFF; // white
		else if (x < 160)
			rgb_value = 0x00000000; // black
		else if (x < 240)
			rgb_value = 0x00FFFF00; // yellow
		else if (x < 320)
			rgb_value = 0x0000FFFF; // cyan
		else if (x < 400)
			rgb_value = 0x0000FF00; // green
		else if (x < 480)
			rgb_value = 0x00FF00FF; // magenta
		else if (x < 560)
			rgb_value = 0x00FF0000; // red
		else if (x < 640)
			rgb_value = 0x000000FF; // blue

		*(pDisplay_data) = rgb_value;
		pDisplay_data++;
		wordnum++;
		x++;
		if (x >= 640){
		 x = 0;
		 pDisplay_data += (1024 - 640);
		 }

  } // while wordnum < word_count


  print("Passed!\n\r");
  return ;

} // end runTestPatternrgb
